local Talented = Talented
local L = LibStub("AceLocale-3.0"):GetLocale("Talented")

function Talented:ApplyTalentPoints(isPet)
	assert (GetCVarBool"previewTalents")
	ResetGroupPreviewTalentPoints(isPet)

	local current, template = self.current, self.template --fixme
	local cp = GetUnspentTalentPoints(isPet)
	local group = GetActiveTalentGroup()

	for tab, tree in ipairs(self:UncompressSpellData(template.class)) do
		local ctab, ttab = current[tab], template[tab]
		for index = 1, #tree do
			local delta = ttab[index] - ctab[index]
			if delta > 0 then
				AddPreviewTalentPoints(tab, index, delta, isPet, group)
				cp = cp - delta
				
			end
		end
	end
	if cp < 0 then
		Talented:Print(L["Error while applying talents! Not enough talent points!"])
		ResetGroupPreviewTalentPoints(isPet)
		Talented:SetTemplate()
		Talented:EnableUI(true)
	else
		LearnPreviewTalents(isPet)
	end
end

function Talented:CheckTalentPointsApplied(isPet)
	local failed
	local current, template = self.current, self.template --fixme
	for tab, tree in ipairs(self:UncompressSpellData(template.class)) do
		local ctab, ttab = current[tab], template[tab]
		for index = 1, #tree do
			local delta = ttab[index] - ctab[index]
			if delta > 0 then
				failed = true
				break
			end
		end
	end
	if failed then
		Talented:Print(L["Error while applying talents! some of the request talents were not set!"])
	else
		local cp = UnitCharacterPoints(isPet and "pet" or "player")
		Talented:Print(L["Template applied successfully, %d talent points remaining."], cp)
	end
	Talented:SetTemplate()
	Talented:EnableUI(true)
end
